' PROGRAMME EXEMPLE - UTILISATION D'UN AFFICHEUR LCD 2 * 16 CARACTERES
'
' ACCES EN MODE 4 BITS - MONTAGE A REALISER :
'
'     PORT //    AFFICHEUR
'
'       D4-----------D4
'       D5-----------D5
'       D6-----------D6
'       D7-----------D7
'     STROBE---------EN
'    AUTOFEED--------RS
'
'                    RW  la masse
'
'                    D3, D2, D1 et D0 en l'air
'                    Commutateur 4/8 bits position "OFF"
'
' AUTEUR : Rmy LUCAS - electroremy@aol.com
'
' SITE WEB : http://www.ifrance.com/electroremy
'

DECLARE SUB adrcg (nb!)
DECLARE SUB mot (mo$)
DECLARE SUB adrdd (nb!)
DECLARE SUB lettre (car$)
DECLARE SUB pause ()
DECLARE SUB port (D7!, D6!, D5!, D4!, rs!)
CLS

'Necessaire pour pouoir initialiser l'afficheur si il a dj
't initialis par une prcdente execution du programme

CALL port(0, 0, 0, 0, 0)

'Ici, l'afficheur s'attends  8 bits. Seulement on lui dit D=0
'donc mode 4bit. Donc le premier appel de FONCTION SET se fait
'en 8 bits mais avec seulement les 4 bits de poids forts pris
'en compte puisque les bits de poids faible sont en l'air.

'FONCTION SET -------------
'         0  0  1  D
CALL port(0, 0, 1, 0, 0)

'Maintenant, accs en mode 4 bits; on transmet d'abord les poids
'forts sur D7...D4, puis les poids faibles toujours sur D7...D4
'avec la procdure PORT(D7, D6, D5, D4, EN, RS)


'DISPLAY ON/OFF CONTROL ---
'         0  0  0  0
CALL port(0, 0, 0, 0, 0)
'         1  D  C  B
CALL port(1, 1, 0, 0, 0)


'ENTRY MODE SET -----------
'         0  0  0  0
CALL port(0, 0, 0, 0, 0)
'         0  1  I  S
CALL port(0, 1, 1, 0, 0)


CALL adrdd(&H0)
CALL mot("Ligne 1")

SOUND 32110, 18

CALL adrdd(&H40)
CALL mot("Ligne 2")

SOUND 32110, 18

CALL adrdd(&H8)
CALL mot("Remy")

SOUND 32110, 18

CALL adrdd(&H48)
CALL mot("LUCAS")

SOUND 32110, 18

'Cursor home --------------
CALL port(0, 0, 0, 0, 0)
CALL port(0, 0, 1, 0, 0)


CALL mot("LIGNE 1")


SOUND 32110, 18


'CURSOR / SCROLLING -------
'         0  0  0  1
CALL port(0, 0, 0, 1, 0)
'         S  R  X  X
CALL port(1, 1, 0, 0, 0)


SOUND 32110, 18


'CURSOR / SCROLLING -------
'         0  0  0  1
CALL port(0, 0, 0, 1, 0)
'         S  R  X  X
CALL port(1, 0, 0, 0, 0)


SOUND 32110, 18


'DISPLAY CLEAR ------------
CALL port(0, 0, 0, 0, 0)
CALL port(0, 0, 0, 1, 0)
 

GOTO pasascii 'Mettez un " ' " devant GOTO pour afficher tous les codes ascii

FOR i = 0 TO 7
  CALL adrdd(&H0)
  FOR ii = 0 TO 15
    CALL lettre(CHR$(i * 32 + ii))
  NEXT ii
  CALL adrdd(&H40)
  FOR ii = 16 TO 31
    CALL lettre(CHR$(i * 32 + ii))
  NEXT ii
  PRINT i * 32; "  "; i * 32 + 31; " - Tapez une touche"
  DO
  LOOP UNTIL INKEY$ <> ""
NEXT i

'DISPLAY CLEAR ------------
CALL port(0, 0, 0, 0, 0)
CALL port(0, 0, 0, 1, 0)

pasascii:


' ON DEFINIT DES CARACTERES PERSO : 5 Colones * 8 Lignes de pixels

CALL adrcg(&H0) ' Caractre perso n 1

'Coeur             C             C  C  C  C            C C C C C
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) ' L
CALL port(0, 0, 0, 0, 1): CALL port(1, 0, 1, 0, 1) ' L     
CALL port(0, 0, 0, 1, 1): CALL port(0, 1, 0, 1, 1) ' L     
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) ' L       
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) ' L       
CALL port(0, 0, 0, 0, 1): CALL port(1, 0, 1, 0, 1) ' L     
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) ' L     
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) ' L

CALL adrcg(&H8) ' Caractre perso n 2

'Coeur plein       
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) '
CALL port(0, 0, 0, 0, 1): CALL port(1, 0, 1, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) '

CALL adrcg(&H10) ' Caractre perso n 3

'Note de musique        
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 1, 0, 1) '         
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 1, 1, 1) '         
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 1, 0, 1) '         
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 1, 0, 1) '         
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 1, 0, 1) '         
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 0, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 0, 0, 1) '     

CALL adrcg(&H18) ' Caractre perso n 4

'Diode vers le bas       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       

CALL adrcg(&H20) ' Caractre perso n 5

'Diode vers le haut       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       

CALL adrcg(&H28) ' Caractre perso n 6

'Rsistance       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) '         
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) '         
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) '         
CALL port(0, 0, 0, 1, 1): CALL port(0, 0, 0, 1, 1) '         
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       

CALL adrcg(&H30) ' Caractre perso n 7

'Condensateur       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) '
CALL port(0, 0, 0, 0, 1): CALL port(0, 0, 0, 0, 1) '
CALL port(0, 0, 0, 1, 1): CALL port(1, 1, 1, 1, 1) '   
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       

CALL adrcg(&H38) ' Caractre perso n 8

'Self         
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(1, 1, 1, 0, 1) '     
CALL port(0, 0, 0, 0, 1): CALL port(0, 1, 0, 0, 1) '       

'AFFICHAGE DES CARACTERES PERSO :

  CALL adrdd(&H0)
  FOR i = 0 TO 7
    CALL lettre(CHR$(i))
  NEXT i

  CALL adrdd(&H40)
  CALL mot("Tapez une touche")
  
  DO
  LOOP UNTIL INKEY$ <> ""

'DISPLAY CLEAR ------------
CALL port(0, 0, 0, 0, 0)
CALL port(0, 0, 0, 1, 0)


END

SUB adrcg (nb)
  IF nb > 63 OR nb < 0 THEN
    PRINT "Erreur ADR CG RAM - Paramtre incorrect"
  ELSE
    IF FIX(nb / 2) = nb / 2 THEN a0 = 0: nb = FIX(nb / 2) ELSE a0 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a1 = 0: nb = FIX(nb / 2) ELSE a1 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a2 = 0: nb = FIX(nb / 2) ELSE a2 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a3 = 0: nb = FIX(nb / 2) ELSE a3 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a4 = 0: nb = FIX(nb / 2) ELSE a4 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a5 = 0: nb = FIX(nb / 2) ELSE a5 = 1: nb = FIX(nb / 2)

    ' ADRESSAGE DD-RAM -----------
    CALL port(0, 1, a5, a4, 0)
    CALL port(a3, a2, a1, a0, 0)
  END IF
END SUB

SUB adrdd (nb)
  IF nb > 127 OR nb < 0 THEN
    PRINT "Erreur ADR DD RAM - Paramtre incorrect"
  ELSE
    IF FIX(nb / 2) = nb / 2 THEN a0 = 0: nb = FIX(nb / 2) ELSE a0 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a1 = 0: nb = FIX(nb / 2) ELSE a1 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a2 = 0: nb = FIX(nb / 2) ELSE a2 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a3 = 0: nb = FIX(nb / 2) ELSE a3 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a4 = 0: nb = FIX(nb / 2) ELSE a4 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a5 = 0: nb = FIX(nb / 2) ELSE a5 = 1: nb = FIX(nb / 2)
    IF FIX(nb / 2) = nb / 2 THEN a6 = 0: nb = FIX(nb / 2) ELSE a6 = 1: nb = FIX(nb / 2)

    ' ADRESSAGE DD-RAM -----------
    CALL port(1, a6, a5, a4, 0)
    CALL port(a3, a2, a1, a0, 0)
  END IF
END SUB

SUB lettre (car$)
nb = ASC(car$)

IF FIX(nb / 2) = nb / 2 THEN a0 = 0: nb = FIX(nb / 2) ELSE a0 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a1 = 0: nb = FIX(nb / 2) ELSE a1 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a2 = 0: nb = FIX(nb / 2) ELSE a2 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a3 = 0: nb = FIX(nb / 2) ELSE a3 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a4 = 0: nb = FIX(nb / 2) ELSE a4 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a5 = 0: nb = FIX(nb / 2) ELSE a5 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a6 = 0: nb = FIX(nb / 2) ELSE a6 = 1: nb = FIX(nb / 2)
IF FIX(nb / 2) = nb / 2 THEN a7 = 0: nb = FIX(nb / 2) ELSE a7 = 1: nb = FIX(nb / 2)

'ECRITURE DONNEE
CALL port(a7, a6, a5, a4, 1)
CALL port(a3, a2, a1, a0, 1)


END SUB

SUB mot (mo$)
  n = LEN(mo$)
  FOR i = 1 TO n
    CALL lettre(MID$(mo$, i, 1))
  NEXT
END SUB

SUB pause
  SOUND 32110, .05
END SUB

SUB port (D7, D6, D5, D4, rs)
'
' D4 = DB4     D5 = DB5
' D6 = DB6     D7 = DB7
' STROBE = E   AUTOFEED = RS
'
' Attention ! Strobe et Autofeed sont en logique inverse !
' => STROBE=1 <-> E=0      STROBE=0 <-> E=1
' => AUTOFEED=1 <-> RS=0   AUTOFEED=0 <-> RS=1
'
 
' E tant mis  0 (strobe = 1), on crit les valeurs de D7,D6,D5,D4 et RS
   
    OUT &H37A, 1 + ((1 - rs) * 2)
    OUT &H378, ((D4 * 16) + (D5 * 32) + (D6 * 64) + (D7 * 128))
    CALL pause

' E est mis  1 (strobe = 0)
' => L'afficheur prends en compte les signaux D7,D6,D5,D4 et RS
   
    OUT &H37A, 0 + ((1 - rs) * 2)
    CALL pause

' E est remis  0 (strobe = 1)

    OUT &H37A, 1 + ((1 - rs) * 2)
    CALL pause

END SUB

